/*
	_o2mm.c
	winmm wrapper for ONE2 on OS/2 + ODIN

	emx + gcc + mm4emx11.zip
	
	2000-01-06	initial
	2000-01-12	notifycd (notifycd.c)
	
	2001-04-22	add RegisterLxDll/UnregisterLxDll (initterm.c)
				mciSendStringA stub (for NScripter)
	
	2001-05-04	mciSendStringA	add option "wait" on command "status"
*/

#define INCL_DOS
#define INCL_OS2MM
#define INCL_MCIOS2
#include "svwrap.h"
#include "notifycd.h"
#ifdef DEBUG
#include <stdio.h>
#endif
#include <string.h>


#ifdef DEBUG

typedef struct { long dummy; } CRTDLL_FILE;
extern CRTDLL_FILE * __cdecl	CRTDLL_fopen(const char *, const char *);
extern void __cdecl	CRTDLL_fclose(CRTDLL_FILE *);
extern void __cdecl	CRTDLL_fprintf(CRTDLL_FILE *, char *,...);

int
put_msg(char * s)
{
	return w32_MessageBoxA((w32_HWND)0, s, "DEBUG", MB_OK);
}
#endif

APIRET os2_DosTmrQueryFreq(PULONG a)
{
	ULONG	rc;
	USHORT	sel = RestoreOS2FS();

	rc = DosTmrQueryFreq(a);
	SetFS(sel);

	return rc;
}

APIRET os2_DosTmrQueryTime(PQWORD a)
{
	ULONG	rc;
	USHORT	sel = RestoreOS2FS();

	rc = DosTmrQueryTime(a);
	SetFS(sel);

	return rc;
}

ULONG
os2_mciSendCommand(USHORT id, USHORT msg, ULONG p1, PVOID p2, USHORT up)
{
	ULONG	rc;
	USHORT	sel;
	
	sel = RestoreOS2FS();
	rc = mciSendCommand(id, msg, p1, p2, up);
	SetFS(sel);
	
	return (rc & 0xffffUL) ? rc : 0L;
}

ULONG
os2_mciSendString(PSZ cmd, PSZ rbuf, USHORT cblen, HWND callback, USHORT id)
{
	ULONG	rc;
	USHORT	sel;
	
	sel = RestoreOS2FS();
	rc = mciSendString(cmd, rbuf, cblen, callback, id);
	SetFS(sel);
	
	return (rc & 0xffffUL) ? rc : 0L;
}

/*

*/


#if defined(NEED_1MS_TICK)
static
DWORD
getTime(void)
{
	static u_int64	tick_cnt;
	u_int64			tick_cur;
	register DWORD	sec, sec1000;
	
	if (tick_cnt == 0) {
		os2_DosTmrQueryFreq((PULONG)(&tick_cnt));
	}
	
	os2_DosTmrQueryTime((PQWORD)(&tick_cur));
	
	sec = (DWORD)(tick_cur / tick_cnt);
	sec1000 = (DWORD)(((tick_cur % tick_cnt) * (u_int64)1000) / tick_cnt);
	
	return sec * 1000UL + sec1000;
}

#endif

w32_MMRESULT w32_API
wrap_timeGetSystemTime(w32_LPMMTIME mm, UINT cb_mm)
{
	w32_MMRESULT	result;
#if !defined(NEED_1MS_TICK)
	result = w32_timeGetSystemTime(mm, cb_mm);
#else
	if (mm->wType == 1) {
		mm->u.ms = getTime();
		result = 0;
	}
	else {
		result = w32_timeGetSystemTime(mm, cb_mm);
	}

#endif
	return result;
}


DWORD w32_API
wrap_timeGetTime(void)
{
	DWORD	result;
	
#if !defined(NEED_1MS_TICK)
	result = w32_timeGetTime();
#else
	result = getTime();
#endif
	return result;
}



UINT w32_API
wrap_auxGetNumDevs(void)
{
	UINT	result;
	
	result = w32_auxGetNumDevs();
	return result;
}

w32_MMRESULT w32_API
wrap_auxGetDevCapsA(UINT id, w32_LPAUXCAPSA auxc, UINT cb_auxc)
{
	w32_MMRESULT	result;
	
	result = w32_auxGetDevCapsA(id, auxc, cb_auxc);
	return result;
}

w32_MMRESULT w32_API
wrap_auxSetVolume(UINT id, DWORD vol)
{
	w32_MMRESULT	result;
	
	result = w32_auxSetVolume(id, vol);
	return result;
}

w32_MMRESULT w32_API
wrap_auxGetVolume(UINT id, w32_LPDWORD lp_vol)
{
	w32_MMRESULT	result;
	
	result = w32_auxGetVolume(id, lp_vol);
	return result;
}


/*----------------------------------------------------------------------------
	MCI commands conversion...

	V{ɂ܂Ⴄli[ĂłˁAOS/2  Win ŁB
	ϊȂႢȂł傤BĂ邩Iiޑj
	
	lI memo:
	EOpen32 EBhEւ MCI_NOTIFY ̓_B
	@Ƃ肠pEBhEĂ݂ (NofityCD)
	EMCI_OPEN ̍ۂ́AtO MCI_WAIT ܂đ҂قS
	@iĂ䂤҂Ȃƈȍ~̃R}hŃG[o邩j
	EMCI_PLAY ͈͔̔肪 Windows ɔ׌Ȃ񂾂낤BĐ͈͂̏I[
	@ŏIgbN + 1 ̒lw肳Ă MCIERR_OUTOFRANGE ɂȂB
	@Ȃ̂ŁAG[o MCI_TO tONAăgC
	E mmsystem.h Ƃ̐؂\́ccł

----------------------------------------------------------------------------*/

#define w32_MCI_DEVNAME_CDA		"cdaudio"

PSZ
validateCDADevName(PSZ szDev, BOOL value_by_num)
{
	PSZ		result = NULL;
	static char	s[32];

	if (value_by_num) {
		USHORT	id = (USHORT)*(PULONG)szDev;
		USHORT	index = (USHORT)(*(PULONG)szDev >> 16);
		BYTE	c[2];
		
		if (id != w32_MCI_DEVTYPE_CD_AUDIO) return NULL;
		strcpy(s, w32_MCI_DEVNAME_CDA);
		c[1] = '\0';
		*c = ((index / 10) % 10) + '0';
		strcat(s, c);
		*c = (index % 10) + '0';
		strcat(s, c);
		szDev = s;
	}
	
	if (memicmp(szDev, w32_MCI_DEVNAME_CDA, 5) == 0) result = szDev;
	
	return result;
}


w32_MCIERROR
mci_Open(DWORD dwFlags, w32_LPMCI_OPEN_PARMSA lpOpen)
{
	w32_MCIERROR	rc;
	MCI_OPEN_PARMS	op;
	ULONG			flag;
	
	flag = 0;
	
	/*
	if (dwFlags & w32_MCI_NOTIFY) flag |= MCI_NOTIFY;
	*/
	
	/*
		I[v҂ĂȂƁAȍ~ MCI R}h
		MCIERR_INSTANCE_INACTIVE ƂG[ԂĂĂ܂炵B
	*/
	flag |= MCI_WAIT;
	
	if (dwFlags & w32_MCI_WAIT) flag |= MCI_WAIT;
	if (dwFlags & w32_MCI_OPEN_ALIAS) flag |= MCI_OPEN_ALIAS;
	if (dwFlags & w32_MCI_OPEN_SHAREABLE) flag |= MCI_OPEN_SHAREABLE;
	/*
	if (dwFlags & w32_MCI_OPEN_TYPE_ID) flag |= MCI_OPEN_TYPE_ID;
	*/
	if (dwFlags & w32_MCI_OPEN_ELEMENT) {
		flag |= MCI_OPEN_ELEMENT;
		/*
		if (dwFlags & w32_MCI_OPEN_ELEMENT_ID) flag |= MCI_OPEN_ELEMENT_ID;
		*/
	}
	
	op.hwndCallback = lpOpen->dwCallback;
	op.usDeviceID = lpOpen->wDeviceID;
	op.usReserved0 = 0;
	op.pszDeviceType = lpOpen->lpstrDeviceType;
/*
	op.pszDeviceType = validateCDADevName(lpOpen->lpstrDeviceType, (dwFlags & w32_MCI_OPEN_TYPE_ID) != 0);
*/
	op.pszElementName = lpOpen->lpstrElementName;
	op.pszAlias = lpOpen->lpstrAlias;

#if 0
	if (op.pszDeviceType != NULL) {
		rc = (w32_MCIERROR)os2_mciSendCommand(0, MCI_OPEN, flag, &op, 0);
		
		lpOpen->dwCallback = op.hwndCallback;
		lpOpen->wDeviceID = op.usDeviceID;
		lpOpen->lpstrDeviceType = op.pszDeviceType;
		lpOpen->lpstrElementName = op.pszElementName;
		lpOpen->lpstrAlias = op.pszAlias;
	}
	else {
#ifdef DEBUG
		w32_MessageBoxA(0, lpOpen->lpstrDeviceType, "Invalid Device", MB_OK);
#endif
		rc = w32_MMSYSERR_NOTSUPPORTED;
	}
#else
	rc = (w32_MCIERROR)os2_mciSendCommand(0, MCI_OPEN, flag, &op, 0);
	if (rc == MCIERR_SUCCESS) {
		lpOpen->dwCallback = op.hwndCallback;
		lpOpen->wDeviceID = op.usDeviceID;
		lpOpen->lpstrDeviceType = op.pszDeviceType;
		lpOpen->lpstrElementName = op.pszElementName;
		lpOpen->lpstrAlias = op.pszAlias;
	}
#endif
	return rc;
}


w32_MCIERROR
mci_Close(w32_MCIDEVICEID id, DWORD dwFlags, w32_LPMCI_GENERIC_PARMS gprm)
{
	w32_MCIERROR	rc;
	ULONG			flag;
	
	flag = 0;
/*
	if (dwFlags & w32_MCI_NOTIFY) flag |= MCI_NOTIFY;
*/
	if (dwFlags & w32_MCI_WAIT) flag |= MCI_WAIT;
	
	rc = (w32_MCIERROR)os2_mciSendCommand((USHORT)id, MCI_CLOSE, flag, gprm, 0);
	
	return rc;
}


w32_MCIERROR
mci_DevCaps(w32_MCIDEVICEID id, DWORD dwFlags, w32_LPMCI_GETDEVCAPS_PARMS lpDev)
{
	w32_MCIERROR	rc;
	ULONG			flag;
	MCI_GETDEVCAPS_PARMS	dev;
	BOOL			query_devtype = FALSE;
	BOOL			conv_mcibool = FALSE;
	ULONG			item;
	
	dev.hwndCallback = (HWND)(lpDev->dwCallback);
	/* dev.ulReturn = lpDev->dwReturn; */
	item = lpDev->dwItem;
	dev.usMessage = 0;
	dev.usReserved0 = 0;
	
	flag = 0;
/*
	if (dwFlags & w32_MCI_NOTIFY) flag |= MCI_NOTIFY;
*/
	if (dwFlags & w32_MCI_WAIT) flag |= MCI_WAIT;
	if (dwFlags & w32_MCI_GETDEVCAPS_ITEM) {
		flag |= MCI_GETDEVCAPS_ITEM;
		conv_mcibool = TRUE;
		switch(item) {
			case w32_MCI_GETDEVCAPS_CAN_EJECT:
				item = MCI_GETDEVCAPS_CAN_EJECT;
				break;
			case w32_MCI_GETDEVCAPS_CAN_PLAY:
				item = MCI_GETDEVCAPS_CAN_PLAY;
				break;
			case w32_MCI_GETDEVCAPS_CAN_RECORD:
				item = MCI_GETDEVCAPS_CAN_RECORD;
				break;
			case w32_MCI_GETDEVCAPS_CAN_SAVE:
				item = MCI_GETDEVCAPS_CAN_SAVE;
				break;
			case w32_MCI_GETDEVCAPS_DEVICE_TYPE:
				item = MCI_GETDEVCAPS_DEVICE_TYPE;
				conv_mcibool = FALSE;
				query_devtype = TRUE;
				break;
			case w32_MCI_GETDEVCAPS_HAS_AUDIO:
				item = MCI_GETDEVCAPS_HAS_AUDIO;
				break;
			case w32_MCI_GETDEVCAPS_HAS_VIDEO:
				item = MCI_GETDEVCAPS_HAS_VIDEO;
				break;
			case w32_MCI_GETDEVCAPS_USES_FILES:
				item = MCI_GETDEVCAPS_USES_FILES;
				break;
			default:
				item = 0;
		}
		
	}
	
	dev.ulItem = item;
	rc = (w32_MCIERROR)os2_mciSendCommand((USHORT)id, MCI_GETDEVCAPS, flag, &dev, 0);
	
	lpDev->dwCallback = (DWORD)(dev.hwndCallback);
	lpDev->dwReturn = dev.ulReturn;
	if (conv_mcibool) { lpDev->dwReturn = (dev.ulReturn == MCI_TRUE); }
	if (query_devtype) {
		DWORD	dt;
		switch(dev.ulReturn) {
			case MCI_DEVTYPE_ANIMATION:
				dt = w32_MCI_DEVTYPE_ANIMATION;
				break;
			case MCI_DEVTYPE_CD_AUDIO:
				dt = w32_MCI_DEVTYPE_CD_AUDIO;
				break;
			case MCI_DEVTYPE_DAT:
				dt = w32_MCI_DEVTYPE_DAT;
				break;
			case MCI_DEVTYPE_DIGITAL_VIDEO:
				dt = w32_MCI_DEVTYPE_DIGITAL_VIDEO;
				break;
			case MCI_DEVTYPE_OTHER:
				dt = w32_MCI_DEVTYPE_OTHER;
				break;
			case MCI_DEVTYPE_OVERLAY:
				dt = w32_MCI_DEVTYPE_OVERLAY;
				break;
			case MCI_DEVTYPE_SEQUENCER:
				dt = w32_MCI_DEVTYPE_SEQUENCER;
				break;
			case MCI_DEVTYPE_VIDEODISC:
				dt = w32_MCI_DEVTYPE_VIDEODISC;
				break;
			case MCI_DEVTYPE_VIDEOTAPE:
				dt = w32_MCI_DEVTYPE_VCR;
				break;
			case MCI_DEVTYPE_WAVEFORM_AUDIO:
				dt = w32_MCI_DEVTYPE_WAVEFORM_AUDIO;
				break;
			default:
				dt = 0;
		}
		lpDev->dwReturn = dt;
	}
	
	return rc;
}


w32_MCIERROR
mci_Play(w32_MCIDEVICEID id, DWORD dwFlags, w32_LPMCI_PLAY_PARMS lpDev)
{
	w32_MCIERROR	rc;
	ULONG			flag;
	MCI_PLAY_PARMS	pp;
	
	pp.hwndCallback = NULLHANDLE;
	pp.ulFrom = lpDev->dwFrom;
	pp.ulTo = lpDev->dwTo;
	
	flag = 0;
/*
	if (dwFlags & w32_MCI_NOTIFY) flag |= MCI_NOTIFY;
*/
	/* u܂Ȃv΍
	   MCI_NOTIFY T|[gĂȂ֌WiłȂjAGfBO 
	   ኱̕soBЂƂ܂ MCI_TO w肵Ă܂Ă    */
	flag |= MCI_TO;

	if (dwFlags & w32_MCI_WAIT) flag |= MCI_WAIT;
	if (dwFlags & w32_MCI_FROM) flag |= MCI_FROM;
	if (dwFlags & w32_MCI_TO) flag |= MCI_TO;
	/* not inplemented additonal flags (for ANIMATION and VIDEODISC) */
	
	
	if (dwFlags & w32_MCI_NOTIFY) {
		NOTIFYCD	ncd;
		
		ncd.id = id;
		ncd.hwnd = (w32_HWND)(lpDev->dwCallback);
		registerNotifyCDWndClass(ncd.hwnd);
		pp.hwndCallback = createNotifyCDWnd(ncd.hwnd, &ncd);
		if (pp.hwndCallback != NULLHANDLE) {
			flag |= MCI_NOTIFY;
		}
	}
	
	rc = (w32_MCIERROR)os2_mciSendCommand((USHORT)id, MCI_PLAY, flag, &pp, 0);
	
	if ((rc & 0xffffUL) == MCIERR_OUTOFRANGE) {
		/* ŏIgbN΍ */
		rc = (w32_MCIERROR)os2_mciSendCommand((USHORT)id
												, MCI_PLAY
												, flag & (~MCI_TO)
												, &pp
												, 0);
	}
	
	if ((rc & 0xffffUL) != 0 && (flag & MCI_NOTIFY) != 0) {
		destroyWnd(pp.hwndCallback);
	}
	
	return rc;
}

w32_MCIERROR
mci_Pause(w32_MCIDEVICEID id, DWORD dwFlags, w32_LPMCI_GENERIC_PARMS gprm)
{
	w32_MCIERROR	rc;
	ULONG			flag;
	
	flag = 0;
/*
	if (dwFlags & w32_MCI_NOTIFY) flag |= MCI_NOTIFY;
*/
	if (dwFlags & w32_MCI_WAIT) flag |= MCI_WAIT;
	
	rc = (w32_MCIERROR)os2_mciSendCommand((USHORT)id, MCI_PAUSE, flag, gprm, 0);
	
	return rc;
}

w32_MCIERROR
mci_Stop(w32_MCIDEVICEID id, DWORD dwFlags, w32_LPMCI_GENERIC_PARMS gprm)
{
	w32_MCIERROR	rc;
	ULONG			flag;
	
	flag = 0;
/*
	if (dwFlags & w32_MCI_NOTIFY) flag |= MCI_NOTIFY;
*/
	if (dwFlags & w32_MCI_WAIT) flag |= MCI_WAIT;
	
	rc = (w32_MCIERROR)os2_mciSendCommand((USHORT)id, MCI_STOP, flag, gprm, 0);
	
	return rc;
}

w32_MCIERROR
mci_Seek(w32_MCIDEVICEID id, DWORD dwFlags, w32_LPMCI_SEEK_PARMS lpSeek)
{
	w32_MCIERROR	rc;
	ULONG			flag;

	flag = 0;
/*
	if (dwFlags & w32_MCI_NOTIFY) flag |= MCI_NOTIFY;
*/
	if (dwFlags & w32_MCI_WAIT) flag |= MCI_WAIT;
	if (dwFlags & w32_MCI_SEEK_TO_END) flag |= MCI_TO_END;
	if (dwFlags & w32_MCI_SEEK_TO_START) flag |= MCI_TO_START;
	if (dwFlags & w32_MCI_TO) flag |= MCI_TO;
	if (dwFlags & w32_MCI_VD_SEEK_REVERSE) flag |= MCI_VD_SEEK_REVERSE;
	
	rc = (w32_MCIERROR)os2_mciSendCommand((USHORT)id, MCI_SEEK, flag, lpSeek, 0);
	
	return rc;
}


w32_MCIERROR
mci_Status(w32_MCIDEVICEID id, DWORD dwFlags, w32_LPMCI_STATUS_PARMS lpStat)
{
	w32_MCIERROR	rc;
	ULONG			flag;
	MCI_STATUS_PARMS	st;
	DWORD			dw;
	BOOL			status_item = FALSE;
	BOOL			query_devmode = FALSE;
	BOOL			query_timeform = FALSE;
	BOOL			query_tracktype = FALSE;
	BOOL			conv_mcibool = FALSE;
	ULONG			item;

	st.hwndCallback = (HWND)(lpStat->dwCallback);
	item = lpStat->dwItem;
	st.ulValue = lpStat->dwTrack;
	
	flag = 0;
/*
	if (dwFlags & w32_MCI_NOTIFY) flag |= MCI_NOTIFY;
*/
	if (dwFlags & w32_MCI_WAIT) flag |= MCI_WAIT;
	if (dwFlags & w32_MCI_STATUS_ITEM) {
		status_item = TRUE;
		flag |= MCI_STATUS_ITEM;
		switch(item) {
			case w32_MCI_STATUS_CURRENT_TRACK:
				item = MCI_STATUS_CURRENT_TRACK;
				break;
			case w32_MCI_STATUS_LENGTH:
				item = MCI_STATUS_LENGTH;
				break;
			case w32_MCI_STATUS_MODE:
				item = MCI_STATUS_MODE;
				query_devmode = TRUE;
				break;
			case w32_MCI_STATUS_POSITION:
				item = MCI_STATUS_POSITION;
				break;
			case w32_MCI_STATUS_NUMBER_OF_TRACKS:
				item = MCI_STATUS_NUMBER_OF_TRACKS;
				break;
			case w32_MCI_STATUS_TIME_FORMAT:
				item = MCI_STATUS_TIME_FORMAT;
				break;
			case w32_MCI_STATUS_MEDIA_PRESENT:
				item = MCI_STATUS_MEDIA_PRESENT;
				conv_mcibool = TRUE;
				break;
			default:
				item = 0;
		}
		
	}
	if (dwFlags & w32_MCI_STATUS_START) {
		flag |= MCI_STATUS_START;
		item = MCI_STATUS_POSITION;
	}
	if (dwFlags & w32_MCI_TRACK) {
		flag |= MCI_TRACK;
		switch(lpStat->dwItem) {
			case w32_MCI_STATUS_POSITION:
				item = MCI_STATUS_POSITION;
				break;
			case w32_MCI_STATUS_LENGTH:
				item = MCI_STATUS_LENGTH;
				break;
			case w32_MCI_CDA_STATUS_TYPE_TRACK:
				item = MCI_CD_STATUS_TRACK_TYPE;
				query_tracktype = TRUE;
				break;
			default:
				break;
		}
	}

	st.ulItem = item;
	
	rc = (w32_MCIERROR)os2_mciSendCommand((USHORT)id, MCI_STATUS, flag, &st, 0);
	
	/*
	lpStat->dwCallback = (DWORD)(st.hwndCallback);
	lpStat->dwItem = st.ulItem;
	*/
	lpStat->dwTrack = st.ulValue;
	dw = st.ulReturn;
	if (query_tracktype) {
		switch(dw) {
			case MCI_CD_TRACK_AUDIO:
				dw = w32_MCI_CDA_TRACK_AUDIO;
				break;
			case MCI_CD_TRACK_DATA:
			case MCI_CD_TRACK_OTHER:
				dw = w32_MCI_CDA_TRACK_OTHER;
				break;
			default:
				dw = 0;
		}
	}
	if (query_devmode) {
		switch(dw) {
			case MCI_MODE_NOT_READY:
				dw = w32_MCI_MODE_NOT_READY;
				break;
			case MCI_MODE_PAUSE:
				dw = w32_MCI_MODE_PAUSE;
				break;
			case MCI_MODE_PLAY:
				dw = w32_MCI_MODE_PLAY;
				break;
			case MCI_MODE_STOP:
				dw = w32_MCI_MODE_STOP;
				break;
			case MCI_MODE_RECORD:
				dw = w32_MCI_MODE_RECORD;
				break;
			case MCI_MODE_SEEK:
				dw = w32_MCI_MODE_SEEK;
				break;
			default:
				dw = 0;
		}
	}
	if (query_timeform) {
		switch(dw) {
			case MCI_FORMAT_MILLISECONDS:
				dw = w32_MCI_FORMAT_MILLISECONDS;
				break;
			case MCI_FORMAT_MSF:
				dw = w32_MCI_FORMAT_MSF;
				break;
			case MCI_FORMAT_TMSF:
				dw = w32_MCI_FORMAT_TMSF;
				break;
			case MCI_FORMAT_FRAMES:
				dw = w32_MCI_FORMAT_FRAMES;
				break;
			case MCI_FORMAT_HMS:
				dw = w32_MCI_FORMAT_HMS;
				break;
			case MCI_FORMAT_SAMPLES:
				dw = w32_MCI_FORMAT_SAMPLES;
				break;
			case MCI_FORMAT_BYTES:
				dw = w32_MCI_FORMAT_BYTES;
				break;
			default:
				dw = 0;
		}
	}
	if (conv_mcibool) {
		dw = (dw == MCI_TRUE);
	}
	
	lpStat->dwReturn = dw;
	
	return rc;
}


w32_MCIERROR
mci_Set(w32_MCIDEVICEID id, DWORD dwFlags, w32_LPMCI_SET_PARMS lpSet)
{
	w32_MCIERROR	rc;
	ULONG			flag;
	MCI_SET_PARMS	st;
	ULONG			audio, tf;

	st.hwndCallback = (HWND)(lpSet->dwCallback);
	audio = lpSet->dwAudio;
	tf = lpSet->dwTimeFormat;
	st.ulSpeedFormat = 0;
	st.ulLevel = 0;
	st.ulOver = 0;
	st.ulItem = 0;
	st.ulValue = 0;
	
	flag = 0;
/*
	if (dwFlags & w32_MCI_NOTIFY) flag |= MCI_NOTIFY;
*/
	if (dwFlags & w32_MCI_WAIT) flag |= MCI_WAIT;
	
	if (dwFlags & w32_MCI_SET_AUDIO) {
		flag |= MCI_SET_AUDIO;
		switch(audio) {
			case w32_MCI_SET_AUDIO_ALL:
				audio = MCI_SET_AUDIO_ALL;
				break;
			case w32_MCI_SET_AUDIO_LEFT:
				audio = MCI_SET_AUDIO_LEFT;
				break;
			case w32_MCI_SET_AUDIO_RIGHT:
				audio = MCI_SET_AUDIO_RIGHT;
				break;
			default:
				audio = 0;
		}
	}
	if (dwFlags & w32_MCI_SET_DOOR_CLOSED) flag |= MCI_SET_DOOR_CLOSED;
	if (dwFlags & w32_MCI_SET_DOOR_OPEN) flag |= MCI_SET_DOOR_OPEN;
	if (dwFlags & w32_MCI_SET_TIME_FORMAT) {
		flag |= MCI_SET_TIME_FORMAT;
		switch(tf) {
			case w32_MCI_FORMAT_MILLISECONDS:
				tf = MCI_FORMAT_MILLISECONDS;
				break;
			case w32_MCI_FORMAT_MSF:
				tf = MCI_FORMAT_MSF;
				break;
			case w32_MCI_FORMAT_TMSF:
				tf = MCI_FORMAT_TMSF;
				break;
			case w32_MCI_FORMAT_FRAMES:
				tf = MCI_FORMAT_FRAMES;
				break;
			case w32_MCI_FORMAT_HMS:
				tf = MCI_FORMAT_HMS;
				break;
			case w32_MCI_FORMAT_SAMPLES:
				tf = MCI_FORMAT_SAMPLES;
				break;
			case w32_MCI_FORMAT_BYTES:
				tf = MCI_FORMAT_BYTES;
				break;
			default:
				tf = 0;
		}
	}
	if (dwFlags & w32_MCI_SET_VIDEO) flag |= MCI_SET_VIDEO;
	if (dwFlags & w32_MCI_SET_ON) flag |= MCI_SET_ON;
	if (dwFlags & w32_MCI_SET_OFF) flag |= MCI_SET_OFF;
	
	st.ulAudio = audio;
	st.ulTimeFormat = tf;
	
	rc = (w32_MCIERROR)os2_mciSendCommand((USHORT)id, MCI_SET, flag, &st, 0);
	
	return rc;
}



w32_MCIERROR w32_API
wrap_mciSendCommandA(w32_MCIDEVICEID id, UINT msg, DWORD p1, DWORD p2)
{
	w32_MCIERROR	result;
	
/*
	result = w32_mciSendCommandA(id, msg, p1, p2);
*/
	switch(msg) {
		case w32_MCI_OPEN:
			result = mci_Open(p1, (w32_LPMCI_OPEN_PARMSA)p2);
#ifdef DEBUG
			if (result | 1) {
				w32_LPMCI_OPEN_PARMSA	op = (w32_LPMCI_OPEN_PARMSA)p2;
				char	s[256];
				sprintf(s, "MCI_OPEN\rID %8lx\rFlag %8lx\rType %s\r result %d"
					, (unsigned)(op->wDeviceID)
					, (unsigned)p1
					, op->lpstrDeviceType
					, (unsigned)result
				);
				put_msg(s);
			}
#endif
			break;
		case w32_MCI_GETDEVCAPS:
			result = mci_DevCaps(id, p1, (w32_LPMCI_GETDEVCAPS_PARMS)p2);
			break;
		case w32_MCI_CLOSE:
			result = mci_Close(id, p1, (w32_LPMCI_GENERIC_PARMS)p2);
			break;
		case w32_MCI_PLAY:
			result = mci_Play(id, p1, (w32_LPMCI_PLAY_PARMS)p2);
#ifdef DEBUG
			{
				w32_LPMCI_PLAY_PARMS	pl = (w32_LPMCI_PLAY_PARMS)p2;
				char	s[256];
				
				sprintf(s, "MCI_PLAY\rID %8lx\rFlag %8X\rFrom %8X\rTo %8X"
					, (unsigned)id
					, (unsigned)p1
					, (unsigned)(pl->dwFrom)
					, (unsigned)(pl->dwTo)
				);
				put_msg(s);
			}
#endif
			break;
		case w32_MCI_PAUSE:
			result = mci_Pause(id, p1, (w32_LPMCI_GENERIC_PARMS)p2);
			break;
		case w32_MCI_STOP:
			result = mci_Stop(id, p1, (w32_LPMCI_GENERIC_PARMS)p2);
			break;
		case w32_MCI_SEEK:
			result = mci_Seek(id, p1, (w32_LPMCI_SEEK_PARMS)p2);
			break;
		case w32_MCI_STATUS:
			result = mci_Status(id, p1, (w32_LPMCI_STATUS_PARMS)p2);
#ifdef DEBUG
			{
				w32_LPMCI_STATUS_PARMS	st = (w32_LPMCI_STATUS_PARMS)p2;
				char	s[256];
				
				sprintf(s, "MCI_STATUS\rID %8lx\rFlag %8X\rdwReturn %8X\rItem %8X\rTrack %8lx"
					, (unsigned)id
					, (unsigned)p1
					, (unsigned)(st->dwReturn)
					, (unsigned)(st->dwItem)
					, (unsigned)(st->dwTrack)
				);
				put_msg(s);
			}
#endif
			break;
		case w32_MCI_SET:
			result = mci_Set(id, p1, (w32_LPMCI_SET_PARMS)p2);
#ifdef DEBUG
			{
				w32_LPMCI_SET_PARMS	st = (w32_LPMCI_SET_PARMS)p2;
				char	s[256];
				sprintf(s, "MCI_SET\rID %8X\rFlag %8X\rdwTimeFormat %8X\rdwAudio %8X"
					, (unsigned)id
					, (unsigned)p1
					, (unsigned)(st->dwTimeFormat)
					, (unsigned)(st->dwAudio)
				);
				put_msg(s);
			}
#endif
			break;
		case w32_MCI_SYSINFO:
		case w32_MCI_INFO:
		
		
		default:
			result = 256 + 1; /* MCIERR_INVALID_DEVICE_ID */
	}

#ifdef DEBUG
	if (result) {
		char	s[256];
		
		sprintf(s, "id %d  msg %8x  err %d (%d)", (unsigned)id, (unsigned)msg, (unsigned)result, (unsigned)(result & 0xffff));
		put_msg(s);
	}
#endif
	
	return result;
}


w32_MCIERROR w32_API
wrap_mciSendStringA(w32_LPSTR szcmd, w32_LPSTR szres, UINT cbres, DWORD hwndcallback)
{
	const char		szwaitcmd[] = "status";
	const char		szwaitopt[] = " wait";
	w32_MCIERROR	rc = w32_MCIERR_UNRECOGNIZED_COMMAND;
	char			stmp[256];
	UINT			cbcmd, cbwaitcmd, cbwaitopt;

	cbcmd = strlen(szcmd);
	cbwaitcmd = sizeof(szwaitcmd) - 1;
	cbwaitopt = sizeof(szwaitopt) - 1;

#ifdef DEBUG
	{
		CRTDLL_FILE	*fo;
		
		fo = CRTDLL_fopen("hoge.log", "ab");
		if (fo) {
			CRTDLL_fprintf(fo, "%s\r\n", (unsigned)szcmd);
			CRTDLL_fclose(fo);
		}
	}
#endif
	
	//
	// status R}ĥƂ wait Ă݂B 
	// iȂƂ̏ŃUg񂪕ԂĂȂۂ̂Łj 
	// open R}hɂꂽق񂩂̂c 
	//
	if (cbcmd > cbwaitcmd && memicmp(szcmd, szwaitcmd, cbwaitcmd) == 0) {
		if (cbcmd + cbwaitopt < sizeof(stmp)) {
			strcpy(stmp, szcmd);
			strcat(stmp, szwaitopt);
			szcmd = stmp;
		}
	}

	// Ƃ肠I wave ĐĂȂA 
	// notify gĂȂȂ̂ŁÂ܂ܓnĂ݂Ƃ 
	rc = (w32_MCIERROR)os2_mciSendString((PSZ)szcmd, (PSZ)szres, (USHORT)cbres, (HWND)hwndcallback, (USHORT)0);
	return rc;
}



BOOL w32_API
wrap_mciGetErrorStringA(w32_MCIERROR errcode, w32_LPSTR buf, UINT buflen)
{
	BOOL	result;

	result = w32_mciGetErrorStringA(errcode, buf, buflen);
	return result;
}



/*
	waveOut 

	{Iɂ Odin ֓nĂ邾B
	
	2000-02-11:
	Ȃ񂩃m PCM ܂ƂɍĐłȂۂȂ̂łނ
	XeIɂĂ݂Br[ɂȂB
	ODIN ̃A OS/2 iVXeHhCoHj̃\͂悭
	킩܂B
*/

w32_MMRESULT w32_API
wrap_waveOutPrepareHeader(w32_HWAVEOUT hwo, w32_LPWAVEHDR lpwh, UINT cbwh)
{
	w32_MMRESULT	rc;

	rc = w32_waveOutPrepareHeader(hwo, lpwh, cbwh);
	return rc;
}

w32_MMRESULT w32_API
wrap_waveOutUnprepareHeader(w32_HWAVEOUT hwo, w32_LPWAVEHDR lpwh, UINT cbwh)
{
	w32_MMRESULT	rc;
	
	rc = w32_waveOutUnprepareHeader(hwo, lpwh, cbwh);
	return rc;
}

w32_MMRESULT w32_API
wrap_waveOutGetVolume(UINT id, w32_LPDWORD lpdw)
{
	w32_MMRESULT	rc;

	rc = w32_waveOutGetVolume(id, lpdw);
	return rc;
}

w32_MMRESULT w32_API
wrap_waveOutSetVolume(UINT id, DWORD dwvol)
{
	w32_MMRESULT	rc;

	rc = w32_waveOutSetVolume(id, dwvol);
	return rc;
}


w32_MMRESULT w32_API
wrap_waveOutOpen(w32_LPHWAVEOUT lphwo
				, UINT id
				, w32_LPWAVEFORMAT lpwf
				, DWORD dwcall
				, DWORD dw_inst
				, DWORD dwopt)
{
	w32_MMRESULT		rc;
	w32_PCMWAVEFORMAT	pcm;

	if (lpwf->wFormatTag == 1 && lpwf->nChannels == 1) {
		/*
			mono->stereo
			
			Tv[g𔼕ɗƂƂƑȕ@őΉB
			if[^Ȃčςނj
		*/
	
		memcpy(&pcm, lpwf, sizeof(w32_PCMWAVEFORMAT));
		pcm.wf.nSamplesPerSec >>= 1;
		pcm.wf.nBlockAlign <<= 1;
		pcm.wf.nChannels = 2;
		pcm.wBitsPerSample <<= 1;
		
		lpwf = (w32_LPWAVEFORMAT)&pcm;
	}

	rc = w32_waveOutOpen(lphwo, id, lpwf, dwcall, dw_inst, dwopt);
	return rc;
}


w32_MMRESULT w32_API
wrap_waveOutClose(w32_HWAVEOUT hwo)
{
	w32_MMRESULT	rc;

	rc = w32_waveOutClose(hwo);
	return rc;
}


w32_MMRESULT w32_API
wrap_waveOutWrite(w32_HWAVEOUT hwo, w32_LPWAVEHDR lpwh, UINT cbwh)
{
	w32_MMRESULT	rc;

	rc = w32_waveOutWrite(hwo, lpwh, cbwh);
	return rc;
}


w32_MMRESULT w32_API
wrap_waveOutReset(w32_HWAVEOUT hwo)
{
	w32_MMRESULT	rc;
	
	rc = w32_waveOutReset(hwo);
	return rc;
}


w32_MMRESULT w32_API
wrap_waveOutGetDevCapsA(UINT id, w32_LPWAVEOUTCAPSA lpwoc, UINT cbwoc)
{
	w32_MMRESULT	rc;
	
	rc = w32_waveOutGetDevCapsA(id, lpwoc, cbwoc);
	return rc;
}




/*

	mixer

*/


w32_MMRESULT w32_API
wrap_mixerClose(w32_HMIXER hmx)
{
	w32_MMRESULT	rc;
	
	rc = w32_mixerClose(hmx);
	return rc;
}

w32_MMRESULT w32_API
wrap_mixerGetControlDetailsA(w32_HMIXEROBJ hmxo
						, w32_LPMIXERCONTROLDETAILS mixcd
						, DWORD flags)
{
	w32_MMRESULT	rc;
	
	rc = w32_mixerGetControlDetailsA(hmxo, mixcd, flags);
	return rc;
}

w32_MMRESULT w32_API
wrap_mixerGetDevCapsA(UINT id, w32_LPMIXERCAPSA mxc, UINT cb_mxc)
{
	w32_MMRESULT	rc;
	
	rc = w32_mixerGetDevCapsA(id, mxc, cb_mxc);
	return rc;
}

w32_MMRESULT w32_API
wrap_mixerGetID(w32_HMIXEROBJ hmxo, UINT *p_id, DWORD flags)
{
	w32_MMRESULT	rc;
	
	rc = w32_mixerGetID(hmxo, p_id, flags);
	return rc;
}

w32_MMRESULT w32_API
wrap_mixerGetLineControlsA(w32_HMIXEROBJ hmxo
						, w32_LPMIXERLINECONTROLSA mxc
						, DWORD flags)
{
	w32_MMRESULT	rc;
	
	rc = w32_mixerGetLineControlsA(hmxo, mxc, flags);
	return rc;
}

w32_MMRESULT w32_API
wrap_mixerGetLineInfoA(w32_HMIXEROBJ hmxo
					, w32_LPMIXERLINEA mxl
					, DWORD flags)
{
	w32_MMRESULT	rc;
	
	rc = w32_mixerGetLineInfoA(hmxo, mxl, flags);
	return rc;

}

UINT w32_API
wrap_mixerGetNumDevs(void)
{
	UINT	rc;
	
	rc = w32_mixerGetNumDevs();
	return rc;
}


DWORD w32_API
wrap_mixerMessage(w32_HMIXER hmx
				, UINT msg
				, DWORD p1
				, DWORD p2)
{
	DWORD	rc;
	
	rc = w32_mixerMessage(hmx, msg, p1, p2);
	return rc;
}


w32_MMRESULT w32_API
wrap_mixerOpen(w32_LPHMIXER p_hmx
			, UINT id
			, DWORD callbk
			, DWORD inst
			, DWORD flags)
{
	w32_MMRESULT	rc;
	
	rc = w32_mixerOpen(p_hmx, id, callbk, inst, flags);
	return rc;
}


w32_MMRESULT w32_API
wrap_mixerSetControlDetails(w32_HMIXEROBJ hmxo
							, w32_LPMIXERCONTROLDETAILS mxcd
							, DWORD flags)
{
	w32_MMRESULT	rc;
	
	rc = w32_mixerSetControlDetails(hmxo, mxcd, flags);
	return rc;
}



/*
	MCIWndCreate (vfw.h)

*/

w32_HWND w32_APIV
wrap_MCIWndCreateA(w32_HWND hparent, w32_HINSTANCE hi, DWORD dw, w32_LPSTR s)
{
	w32_HWND	hwnd;
	
	hwnd = w32_MCIWndCreateA(hparent, hi, dw, s);
	return hwnd;
}
