/*

*/

#define INCL_DOS
#define INCL_PM
#define INCL_OS2MM
#define INCL_MCIOS2
#include "svwrap.h"
#include "notifycd.h"
#ifdef DEBUG
#include <stdio.h>
#endif

HAB
os2_WinQueryAnchorBlock(HWND hwnd)
{
	HAB		rc;
	USHORT	sel;
	
	sel = RestoreOS2FS();
	rc = WinQueryAnchorBlock(hwnd);
	SetFS(sel);
	
	return rc;
}


BOOL
os2_WinIsWindow(HAB hab, HWND hwnd)
{
	BOOL	rc;
	USHORT	sel;

	sel = RestoreOS2FS();
	rc = WinIsWindow(hab, hwnd);
	SetFS(sel);
	
	return rc;
}


BOOL
os2_WinRegisterClass(HAB hab, PCSZ clsname, PFNWP wndp, ULONG style, ULONG cb)
{
	BOOL	rc;
	USHORT	sel;

	sel = RestoreOS2FS();
	rc = WinRegisterClass(hab, clsname, wndp, style, cb);
	SetFS(sel);
	
	return rc;
}

HWND
os2_WinCreateWindow(HWND hwnd_p, PSZ clsname, PSZ txt, ULONG style, LONG x, LONG y, LONG cx, LONG cy, HWND hwnd_o, HWND hwnd_b, ULONG id, PVOID pctl, PVOID pprm)
{
	HWND	rc;
	USHORT	sel;

	sel = RestoreOS2FS();
	rc = WinCreateWindow(hwnd_p
						, clsname
						, txt
						, style
						, x, y
						, cx, cy
						, hwnd_o
						, hwnd_b
						, id
						, pctl
						, pprm);
	SetFS(sel);
	
	return rc;
}

BOOL
os2_WinDestroyWindow(HWND hwnd)
{
	BOOL	rc;
	USHORT	sel;

	sel = RestoreOS2FS();
	rc = WinDestroyWindow(hwnd);
	SetFS(sel);
	
	return rc;
}


BOOL
os2_WinSetWindowPtr(HWND hwnd, LONG idx, PVOID pp)
{
	BOOL	rc;
	USHORT	sel;

	sel = RestoreOS2FS();
	rc = WinSetWindowPtr(hwnd, idx, pp);
	SetFS(sel);
	
	return rc;
}

PVOID
os2_WinQueryWindowPtr(HWND hwnd, LONG idx)
{
	PVOID	rc;
	USHORT	sel;

	sel = RestoreOS2FS();
	rc = WinQueryWindowPtr(hwnd, idx);
	SetFS(sel);
	
	return rc;
}


MRESULT
os2_WinDefWindowProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
	MRESULT	rc;
	USHORT	sel;

	sel = RestoreOS2FS();
	rc = WinDefWindowProc(hwnd, msg, mp1, mp2);
	SetFS(sel);
	
	return rc;
}


APIRET
os2_DosAllocMem(PPVOID ppb, ULONG cb, ULONG flag)
{
	APIRET	rc;
	USHORT	sel;

	sel = RestoreOS2FS();
	rc = DosAllocMem(ppb, cb, flag);
	SetFS(sel);
	
	return rc;
}

APIRET
os2_DosFreeMem(PVOID pb)
{
	APIRET	rc;
	USHORT	sel;

	sel = RestoreOS2FS();
	rc = DosFreeMem(pb);
	SetFS(sel);
	
	return rc;
}


BOOL
destroyWnd(HWND hwnd)
{
	return os2_WinDestroyWindow(hwnd);
}


#ifdef DEBUG
ERRORID
os2_WinGetLastError(HAB hab)
{
	ERRORID	rc;
	USHORT	sel;

	sel = RestoreOS2FS();
	rc = WinGetLastError(hab);
	SetFS(sel);
	
	return rc;
}
#endif


/*
	Create NotifyCD Window...
*/


BOOL
registerNotifyCDWndClass(w32_HWND w32_hwnd)
{
	BOOL	result;
	HWND	hwnd;
	HAB		hab;
	
	hwnd = Win32ToOS2Handle(w32_hwnd);
	hab = os2_WinQueryAnchorBlock(hwnd);

#ifdef DEBUG
	{
		char	s[256];
		
		sprintf(s, "Win Handle %08x (%s)\rOS2 hdl %08x (%s)"
			, w32_hwnd
			, w32_IsWindow(w32_hwnd) ? "TRUE" : "FALSE"
			, hwnd
			, os2_WinIsWindow(hab, hwnd) ? "TRUE" : "FALSE");
		MessageBox(NULL, s, "DEBUG", MB_OK);
	}
#endif

	
	if (hab == NULLHANDLE) {
#ifdef DEBUG
		w32_MessageBoxA(NULL, "NotifyCD : fail to get HAB!", "DEBUG", MB_OK);
#endif
		return FALSE;
	}
	
	result = os2_WinRegisterClass(hab
							, NOTIFYCD_CLASS
							, NotifyCDWndProc
							, 0L
							, sizeof(PVOID));
	
	return result;
}


HWND
createNotifyCDWnd(w32_HWND w32_hwnd, PNOTIFYCD ncd)
{
	HWND	hwnd, hwnd_p;
	
	hwnd_p = Win32ToOS2Handle(w32_hwnd);
	if (hwnd_p == NULLHANDLE) return NULLHANDLE;
#ifdef DEBUG	
	{
		HAB	hab = os2_WinQueryAnchorBlock(hwnd_p);
		if (!os2_WinIsWindow(hab, hwnd_p)) {
			char	s[256];
			
			sprintf(s, "Win Handle %08x\rOS2 hdl %08x", w32_hwnd, hwnd_p);
			MessageBox(NULL, s, "DEBUG", MB_OK);
		}
	}
#endif	
	hwnd = os2_WinCreateWindow(hwnd_p
							, NOTIFYCD_CLASS
							, "catch and kludge your Medium..."
							, 0
							, 0, 0
							, 1, 1
							, hwnd_p
							, HWND_BOTTOM
							, -1
							, NULL
							, ncd);
#ifdef DEBUG
	if (hwnd == NULLHANDLE) {
		char	s[256];
		sprintf(s, "NOTIFYWnd\rfail to create\rerr %04x"
			, os2_WinGetLastError(os2_WinQueryAnchorBlock(hwnd_p)));
		MessageBox(NULL, s, "DEBUG", MB_OK);
	}
#endif
	return hwnd;
}



MRESULT EXPENTRY
NotifyCDWndProc(HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
{
	MRESULT		rc = FALSE;
	
	switch(msg) {
		case WM_CREATE: {
			PVOID	pv = NULL;
			os2_DosAllocMem(&pv, sizeof(NOTIFYCD), PAG_COMMIT | PAG_READ | PAG_WRITE);
			if (pv) {
				memcpy(pv, ((PCREATESTRUCT)mp2)->pPresParams,sizeof(NOTIFYCD));
				os2_WinSetWindowPtr(hwnd, QWL_USER, pv);
			} else {
#ifdef DEBUG
				MessageBox(NULL, "Mem err", "DEBUG", MB_OK);
#endif
				rc = (MRESULT)TRUE;		/* discontinue... */
			}
			break;
		}
		
		case MM_MCINOTIFY: {
			USHORT	code = SHORT1FROMMP(mp1);
			USHORT	usrprm = SHORT2FROMMP(mp1);
			USHORT	devid = SHORT1FROMMP(mp2);
			USHORT	msgid = SHORT2FROMMP(mp2);
			w32_WORD	w32code;
			
			switch(code) {
				case MCI_NOTIFY_SUCCESSFUL:
					w32code = w32_MCI_NOTIFY_SUCCESSFUL;
					break;
				case MCI_NOTIFY_ABORTED:
					w32code = w32_MCI_NOTIFY_ABORTED;
					break;
				case MCI_NOTIFY_SUPERSEDED:
					w32code = w32_MCI_NOTIFY_SUPERSEDED;
					break;
				default:
					w32code = w32_MCI_NOTIFY_FAILURE;
					break;
			}
			
			if (w32code) {
				PNOTIFYCD pncd = (PNOTIFYCD)os2_WinQueryWindowPtr(hwnd, QWL_USER);
				if (w32_IsWindow(pncd->hwnd)) {
#ifdef DEBUG
					{ char s[256];
					sprintf(s, "NOTIFY\rID %d\rcode %04x"
							, devid
							, w32code);
					MessageBox(NULL, s, "DEBUG", MB_OK);
					}
#endif
					w32_SendMessageA(pncd->hwnd
								, w32_MM_MCINOTIFY
								, (w32_WPARAM)w32code
								, (w32_LPARAM)devid);
				}
			}
			os2_WinDestroyWindow(hwnd);
			break;
		}
		
		case WM_DESTROY: {		/* ꉞĂ݂BȂẮH */
			PVOID	pv = os2_WinQueryWindowPtr(hwnd, QWL_USER);
			if (pv) {
				if (os2_DosFreeMem(pv) == 0)
					os2_WinSetWindowPtr(hwnd, QWL_USER, NULL);
			}
			break;
		}
		default:
			rc = os2_WinDefWindowProc(hwnd, msg, mp1, mp2);
			break;
	}
	return rc;
}
