/*

	svwrap/w32def.h

*/

#ifndef svwrap_w32def_h__
#define svwrap_w32def_h__

#ifdef __cplusplus
extern "C" {
#endif


#define w32_NEAR
#define w32_FAR


#define DECL_W32TYPE(porg, pnew) \
	typedef porg	w32_##pnew, * w32_P##pnew, w32_FAR * w32_LP##pnew;

#define DECL_W32HDL(hdl) \
	typedef unsigned long \
	w32_##hdl, * w32_P##hdl, w32_FAR * w32_LP##hdl;


#if defined(__GNUC__) && (__GNUC__ == 2) && (__GNUC_MINOR__ >= 7)
#define __stdcall __attribute__((__stdcall__))
#define __cdecl   __attribute__((__cdecl__))
#define __RESTORE_ES  __asm__ __volatile__("pushl %ds\n\tpopl %es")
#endif

#if defined(__WATCOMC__)
#pragma aux _stdcall_wc "*" parm routine [] value struct struct caller [] modify [eax ecx edx];
#pragma aux _cdecl_wc "_*" parm caller [] value struct float struct routine [eax] modify [eax ecx edx];
#define w32_API
#else
#define w32_API		__stdcall
#endif

#define w32_APIV	__cdecl

#define odinHELPERAPI		_System


#define w32_MAXPNAMELEN		32
#define w32_MAXERRORLENGTH	128


DECL_W32TYPE(int, BOOL)
DECL_W32TYPE(char, CHAR)
DECL_W32TYPE(int, INT)
DECL_W32TYPE(long, LONG)
DECL_W32TYPE(unsigned int, UINT)
DECL_W32TYPE(unsigned int, USHORT)
DECL_W32TYPE(unsigned long, ULONG)

typedef char	*w32_PSZ, w32_NEAR *w32_PSTR, w32_FAR *w32_LPSTR;

DECL_W32TYPE(unsigned char, BYTE)
DECL_W32TYPE(unsigned short, WORD)
DECL_W32TYPE(unsigned long, DWORD)

#define w32_VOID	void
typedef void		*w32_PVOID, *w32_LPVOID;

DECL_W32TYPE(UINT, WPARAM)
DECL_W32TYPE(ULONG, LPARAM)
DECL_W32TYPE(LONG, LRESULT)


DECL_W32HDL(HANDLE)
DECL_W32TYPE(w32_HANDLE, HWND)
DECL_W32TYPE(w32_HANDLE, HINSTANCE)


USHORT odinHELPERAPI  GetFS(void);
void odinHELPERAPI  SetFS(USHORT sel);
USHORT odinHELPERAPI  RestoreOS2FS(void);
USHORT odinHELPERAPI  SetReturnFS(USHORT sel);

// HWND odinHELPERAPI  Win32ToOS2Handle(w32_HWND);
HWND w32_API  Win32ToOS2Handle(w32_HWND);
#if defined(__WATCOMC__)
#pragma aux (_stdcall_wc) Win32ToOS2Handle;
#endif

DWORD w32_API RegisterLxDll(w32_HINSTANCE , void *EntryPoint, PVOID pResData, DWORD MajorImageVersion, DWORD MinorImageVersion,  DWORD Subsystem);

BOOL w32_API UnregisterLxDll(DWORD hInstance);

#ifdef __cplusplus
}
#endif

#endif /* svwrap_w32def_h__ */
