/*
	svwrap/w32mm.h

*/

#ifndef svwrap_w32mm_h__
#define svwrap_w32mm_h__

#if !defined(svwrap_w32def_h__)
#include "w32def.h"
#endif

#ifdef __cplusplus
extern "C" {
#endif


DECL_W32TYPE(w32_UINT, MMRESULT)
DECL_W32TYPE(w32_DWORD, MCIERROR)
DECL_W32TYPE(w32_UINT, MCIDEVICEID)
DECL_W32TYPE(w32_UINT, MMVERSION)

DECL_W32HDL(HWAVEOUT)
DECL_W32HDL(HMIXER)
DECL_W32HDL(HMIXEROBJ)


#define w32_TIME_MS			0x1
#define w32_TIME_SAMPLES	0x2
#define w32_TIME_BYTES		0x4
#define w32_TIME_SMPTE		0x8
#define w32_TIME_MIDI		0x10
#define w32_TIME_TICKS		0x20

#define w32_MM_MCINOTIFY		0x3B9

#define w32_MM_WOM_OPEN			0x3BB
#define w32_MM_WOM_CLOSE		0x3BC
#define w32_MM_WOM_DONE			0x3BD

#define w32_MM_WIM_OPEN			0x3BE
#define w32_MM_WIM_CLOSE		0x3BF
#define w32_MM_WIM_DATA			0x3C0

#define w32_MM_MIM_OPEN 		0x3C1
#define w32_MM_MIM_CLOSE		0x3C2
#define w32_MM_MIM_DATA			0x3C3
#define w32_MM_MIM_LONGDATA		0x3C4
#define w32_MM_MIM_ERROR		0x3C5
#define w32_MM_MIM_LONGERROR	0x3C6

#define w32_MM_MOM_OPEN			0x3C7
#define w32_MM_MOM_CLOSE		0x3C8
#define w32_MM_MOM_DONE			0x3C9
#define w32_MM_MOM_POSITIONCB	0x3CA

#define w32_MM_MCISIGNAL		0x3CB
#define w32_MM_MIM_MOREDATA		0x3CC

#define w32_MM_MIXM_LINE_CHANGE		0x3D0
#define w32_MM_MIXM_CONTROL_CHANGE	0x3D1

#define w32_MM_STREAM_OPEN		0x3D4
#define w32_MM_STREAM_CLOSE		0x3D5
#define w32_MM_STREAM_DONE		0x3D6
#define w32_MM_STREAM_ERROR		0x3D7



#define w32_MMSYSERR_BASE          0
#define w32_WAVERR_BASE            32
#define w32_MIDIERR_BASE           64
#define w32_TIMERR_BASE            96
#define w32_JOYERR_BASE            160
#define w32_MCIERR_BASE            256
#define w32_MIXERR_BASE            1024

#define w32_MCI_STRING_OFFSET      512
#define w32_MCI_VD_OFFSET          1024
#define w32_MCI_CD_OFFSET          1088
#define w32_MCI_WAVE_OFFSET        1152
#define w32_MCI_SEQ_OFFSET         1216



#define w32_MMSYSERR_NOERROR		0
#define w32_MMSYSERR_ERROR			(w32_MMSYSERR_BASE + 1)
#define w32_MMSYSERR_BADDEVICEID	(w32_MMSYSERR_BASE + 2)
#define w32_MMSYSERR_NOTENABLED		(w32_MMSYSERR_BASE + 3)
#define w32_MMSYSERR_ALLOCATED		(w32_MMSYSERR_BASE + 4)
#define w32_MMSYSERR_INVALHANDLE	(w32_MMSYSERR_BASE + 5)
#define w32_MMSYSERR_NODRIVER		(w32_MMSYSERR_BASE + 6)
#define w32_MMSYSERR_NOMEM			(w32_MMSYSERR_BASE + 7)
#define w32_MMSYSERR_NOTSUPPORTED	(w32_MMSYSERR_BASE + 8)
#define w32_MMSYSERR_BADERRNUM		(w32_MMSYSERR_BASE + 9)
#define w32_MMSYSERR_INVALFLAG		(w32_MMSYSERR_BASE + 10)
#define w32_MMSYSERR_INVALPARAM		(w32_MMSYSERR_BASE + 11)
#define w32_MMSYSERR_HANDLEBUSY		(w32_MMSYSERR_BASE + 12)
#define w32_MMSYSERR_INVALIDALIAS	(w32_MMSYSERR_BASE + 13)
#define w32_MMSYSERR_BADDB			(w32_MMSYSERR_BASE + 14)
#define w32_MMSYSERR_KEYNOTFOUND	(w32_MMSYSERR_BASE + 15)
#define w32_MMSYSERR_READERROR		(w32_MMSYSERR_BASE + 16)
#define w32_MMSYSERR_WRITEERROR		(w32_MMSYSERR_BASE + 17)
#define w32_MMSYSERR_DELETEERROR	(w32_MMSYSERR_BASE + 18)
#define w32_MMSYSERR_VALNOTFOUND	(w32_MMSYSERR_BASE + 19)
#define w32_MMSYSERR_NODRIVERCB		(w32_MMSYSERR_BASE + 20)
#define w32_MMSYSERR_LASTERROR		(w32_MMSYSERR_BASE + 20)



/*

w32_MCIs

*/


#define w32_MCIERR_INVALID_DEVICE_ID		(w32_MCIERR_BASE + 1)
#define w32_MCIERR_UNRECOGNIZED_KEYWORD		(w32_MCIERR_BASE + 3)
#define w32_MCIERR_UNRECOGNIZED_COMMAND		(w32_MCIERR_BASE + 5)
#define w32_MCIERR_HARDWARE					(w32_MCIERR_BASE + 6)
#define w32_MCIERR_INVALID_DEVICE_NAME		(w32_MCIERR_BASE + 7)
#define w32_MCIERR_OUT_OF_MEMORY			(w32_MCIERR_BASE + 8)
#define w32_MCIERR_DEVICE_OPEN				(w32_MCIERR_BASE + 9)
#define w32_MCIERR_CANNOT_LOAD_DRIVER		(w32_MCIERR_BASE + 10)
#define w32_MCIERR_MISSING_COMMAND_STRING	(w32_MCIERR_BASE + 11)
#define w32_MCIERR_PARAM_OVERFLOW			(w32_MCIERR_BASE + 12)
#define w32_MCIERR_MISSING_STRING_ARGUMENT	(w32_MCIERR_BASE + 13)
#define w32_MCIERR_BAD_INTEGER				(w32_MCIERR_BASE + 14)
#define w32_MCIERR_PARSER_INTERNAL			(w32_MCIERR_BASE + 15)
#define w32_MCIERR_DRIVER_INTERNAL			(w32_MCIERR_BASE + 16)
#define w32_MCIERR_MISSING_PARAMETER		(w32_MCIERR_BASE + 17)
#define w32_MCIERR_UNSUPPORTED_FUNCTION		(w32_MCIERR_BASE + 18)
#define w32_MCIERR_FILE_NOT_FOUND			(w32_MCIERR_BASE + 19)
#define w32_MCIERR_DEVICE_NOT_READY			(w32_MCIERR_BASE + 20)
#define w32_MCIERR_INTERNAL					(w32_MCIERR_BASE + 21)
#define w32_MCIERR_DRIVER					(w32_MCIERR_BASE + 22)
#define w32_MCIERR_CANNOT_USE_ALL			(w32_MCIERR_BASE + 23)
#define w32_MCIERR_MULTIPLE					(w32_MCIERR_BASE + 24)
#define w32_MCIERR_EXTENSION_NOT_FOUND		(w32_MCIERR_BASE + 25)
#define w32_MCIERR_OUTOFRANGE				(w32_MCIERR_BASE + 26)
#define w32_MCIERR_FLAGS_NOT_COMPATIBLE		(w32_MCIERR_BASE + 28)
#define w32_MCIERR_FILE_NOT_SAVED			(w32_MCIERR_BASE + 30)
#define w32_MCIERR_DEVICE_TYPE_REQUIRED		(w32_MCIERR_BASE + 31)
#define w32_MCIERR_DEVICE_LOCKED			(w32_MCIERR_BASE + 32)
#define w32_MCIERR_DUPLICATE_ALIAS			(w32_MCIERR_BASE + 33)
#define w32_MCIERR_BAD_CONSTANT				(w32_MCIERR_BASE + 34)
#define w32_MCIERR_MUST_USE_SHAREABLE		(w32_MCIERR_BASE + 35)
#define w32_MCIERR_MISSING_DEVICE_NAME		(w32_MCIERR_BASE + 36)
#define w32_MCIERR_BAD_TIME_FORMAT			(w32_MCIERR_BASE + 37)
#define w32_MCIERR_NO_CLOSING_QUOTE			(w32_MCIERR_BASE + 38)
#define w32_MCIERR_DUPLICATE_FLAGS			(w32_MCIERR_BASE + 39)
#define w32_MCIERR_INVALID_FILE				(w32_MCIERR_BASE + 40)
#define w32_MCIERR_NULL_PARAMETER_BLOCK		(w32_MCIERR_BASE + 41)
#define w32_MCIERR_UNNAMED_RESOURCE			(w32_MCIERR_BASE + 42)
#define w32_MCIERR_NEW_REQUIRES_ALIAS		(w32_MCIERR_BASE + 43)
#define w32_MCIERR_NOTIFY_ON_AUTO_OPEN		(w32_MCIERR_BASE + 44)
#define w32_MCIERR_NO_ELEMENT_ALLOWED		(w32_MCIERR_BASE + 45)
#define w32_MCIERR_NONAPPLICABLE_FUNCTION	(w32_MCIERR_BASE + 46)
#define w32_MCIERR_ILLEGAL_FOR_AUTO_OPEN	(w32_MCIERR_BASE + 47)
#define w32_MCIERR_FILENAME_REQUIRED		(w32_MCIERR_BASE + 48)
#define w32_MCIERR_EXTRA_CHARACTERS			(w32_MCIERR_BASE + 49)
#define w32_MCIERR_DEVICE_NOT_INSTALLED		(w32_MCIERR_BASE + 50)
#define w32_MCIERR_GET_CD					(w32_MCIERR_BASE + 51)
#define w32_MCIERR_SET_CD					(w32_MCIERR_BASE + 52)
#define w32_MCIERR_SET_DRIVE				(w32_MCIERR_BASE + 53)
#define w32_MCIERR_DEVICE_LENGTH			(w32_MCIERR_BASE + 54)
#define w32_MCIERR_DEVICE_ORD_LENGTH		(w32_MCIERR_BASE + 55)
#define w32_MCIERR_NO_INTEGER				(w32_MCIERR_BASE + 56)

#define w32_MCIERR_WAVE_OUTPUTSINUSE		(w32_MCIERR_BASE + 64)
#define w32_MCIERR_WAVE_SETOUTPUTINUSE		(w32_MCIERR_BASE + 65)
#define w32_MCIERR_WAVE_INPUTSINUSE			(w32_MCIERR_BASE + 66)
#define w32_MCIERR_WAVE_SETINPUTINUSE		(w32_MCIERR_BASE + 67)
#define w32_MCIERR_WAVE_OUTPUTUNSPECIFIED	(w32_MCIERR_BASE + 68)
#define w32_MCIERR_WAVE_INPUTUNSPECIFIED	(w32_MCIERR_BASE + 69)
#define w32_MCIERR_WAVE_OUTPUTSUNSUITABLE	(w32_MCIERR_BASE + 70)
#define w32_MCIERR_WAVE_SETOUTPUTUNSUITABLE	(w32_MCIERR_BASE + 71)
#define w32_MCIERR_WAVE_INPUTSUNSUITABLE	(w32_MCIERR_BASE + 72)
#define w32_MCIERR_WAVE_SETINPUTUNSUITABLE	(w32_MCIERR_BASE + 73)

#define w32_MCIERR_SEQ_DIV_INCOMPATIBLE		(w32_MCIERR_BASE + 80)
#define w32_MCIERR_SEQ_PORT_INUSE			(w32_MCIERR_BASE + 81)
#define w32_MCIERR_SEQ_PORT_NONEXISTENT		(w32_MCIERR_BASE + 82)
#define w32_MCIERR_SEQ_PORT_MAPNODEVICE		(w32_MCIERR_BASE + 83)
#define w32_MCIERR_SEQ_PORT_MISCERROR		(w32_MCIERR_BASE + 84)
#define w32_MCIERR_SEQ_TIMER				(w32_MCIERR_BASE + 85)
#define w32_MCIERR_SEQ_PORTUNSPECIFIED		(w32_MCIERR_BASE + 86)
#define w32_MCIERR_SEQ_NOMIDIPRESENT		(w32_MCIERR_BASE + 87)

#define w32_MCIERR_NO_WINDOW				(w32_MCIERR_BASE + 90)
#define w32_MCIERR_CREATEWINDOW				(w32_MCIERR_BASE + 91)
#define w32_MCIERR_FILE_READ				(w32_MCIERR_BASE + 92)
#define w32_MCIERR_FILE_WRITE				(w32_MCIERR_BASE + 93)

#define w32_MCIERR_NO_IDENTITY				(w32_MCIERR_BASE + 94)

#define w32_MCIERR_CUSTOM_DRIVER_BASE		(w32_MCIERR_BASE + 256)


#define w32_MCI_FIRST		0x800	/* DRV_MCI_FIRST */

#define w32_MCI_OPEN		0x0803
#define w32_MCI_CLOSE		0x0804
#define w32_MCI_ESCAPE		0x0805
#define w32_MCI_PLAY		0x0806
#define w32_MCI_SEEK		0x0807
#define w32_MCI_STOP		0x0808
#define w32_MCI_PAUSE		0x0809
#define w32_MCI_INFO		0x080A
#define w32_MCI_GETDEVCAPS	0x080B
#define w32_MCI_SPIN		0x080C
#define w32_MCI_SET			0x080D
#define w32_MCI_STEP		0x080E
#define w32_MCI_RECORD		0x080F
#define w32_MCI_SYSINFO		0x0810
#define w32_MCI_BREAK		0x0811
#define w32_MCI_SAVE		0x0813
#define w32_MCI_STATUS		0x0814
#define w32_MCI_CUE			0x0830
#define w32_MCI_REALIZE		0x0840
#define w32_MCI_WINDOW		0x0841
#define w32_MCI_PUT			0x0842
#define w32_MCI_WHERE		0x0843
#define w32_MCI_FREEZE		0x0844
#define w32_MCI_UNFREEZE	0x0845
#define w32_MCI_LOAD		0x0850
#define w32_MCI_CUT			0x0851
#define w32_MCI_COPY		0x0852
#define w32_MCI_PASTE		0x0853
#define w32_MCI_UPDATE		0x0854
#define w32_MCI_RESUME		0x0855
#define w32_MCI_DELETE		0x0856

#define w32_MCI_USER_MESSAGES	0xc00	/* (DRV_MCI_FIRST + 0x400) */
#define w32_MCI_LAST			0x0FFF

#define w32_MCI_ALL_DEVICE_ID		((w32_MCIDEVICEID)(-1))

#define w32_MCI_DEVTYPE_VCR			513	/* (w32_MCI_STRING_OFFSET + 1) */
#define w32_MCI_DEVTYPE_VIDEODISC	514	/* (w32_MCI_STRING_OFFSET + 2) */
#define w32_MCI_DEVTYPE_OVERLAY		515	/* (w32_MCI_STRING_OFFSET + 3) */
#define w32_MCI_DEVTYPE_CD_AUDIO	516	/* (w32_MCI_STRING_OFFSET + 4) */
#define w32_MCI_DEVTYPE_DAT			517	/* (w32_MCI_STRING_OFFSET + 5) */
#define w32_MCI_DEVTYPE_SCANNER		518	/* (w32_MCI_STRING_OFFSET + 6) */
#define w32_MCI_DEVTYPE_ANIMATION	519	/* (w32_MCI_STRING_OFFSET + 7) */
#define w32_MCI_DEVTYPE_DIGITAL_VIDEO	520	/* (w32_MCI_STRING_OFFSET + 8) */
#define w32_MCI_DEVTYPE_OTHER		521	/* (w32_MCI_STRING_OFFSET + 9) */
#define w32_MCI_DEVTYPE_WAVEFORM_AUDIO	522	/* (w32_MCI_STRING_OFFSET + 10) */
#define w32_MCI_DEVTYPE_SEQUENCER	523	/* (w32_MCI_STRING_OFFSET + 11) */

#define w32_MCI_DEVTYPE_FIRST		w32_MCI_DEVTYPE_VCR
#define w32_MCI_DEVTYPE_LAST		w32_MCI_DEVTYPE_SEQUENCER

#define w32_MCI_DEVTYPE_FIRST_USER	0x1000

#define w32_MCI_MODE_NOT_READY	(w32_MCI_STRING_OFFSET + 12)
#define w32_MCI_MODE_STOP	(w32_MCI_STRING_OFFSET + 13)
#define w32_MCI_MODE_PLAY	(w32_MCI_STRING_OFFSET + 14)
#define w32_MCI_MODE_RECORD	(w32_MCI_STRING_OFFSET + 15)
#define w32_MCI_MODE_SEEK	(w32_MCI_STRING_OFFSET + 16)
#define w32_MCI_MODE_PAUSE	(w32_MCI_STRING_OFFSET + 17)
#define w32_MCI_MODE_OPEN	(w32_MCI_STRING_OFFSET + 18)

#define w32_MCI_FORMAT_MILLISECONDS	0
#define w32_MCI_FORMAT_HMS			1
#define w32_MCI_FORMAT_MSF			2
#define w32_MCI_FORMAT_FRAMES		3
#define w32_MCI_FORMAT_SMPTE_24		4
#define w32_MCI_FORMAT_SMPTE_25		5
#define w32_MCI_FORMAT_SMPTE_30		6
#define w32_MCI_FORMAT_SMPTE_30DROP	7
#define w32_MCI_FORMAT_BYTES		8
#define w32_MCI_FORMAT_SAMPLES		9
#define w32_MCI_FORMAT_TMSF			10


#define w32_MCI_NOTIFY_SUCCESSFUL	0x0001
#define w32_MCI_NOTIFY_SUPERSEDED	0x0002
#define w32_MCI_NOTIFY_ABORTED		0x0004
#define w32_MCI_NOTIFY_FAILURE		0x0008

#define w32_MCI_NOTIFY			0x00000001L
#define w32_MCI_WAIT			0x00000002L
#define w32_MCI_FROM			0x00000004L
#define w32_MCI_TO				0x00000008L
#define w32_MCI_TRACK			0x00000010L

#define w32_MCI_OPEN_SHAREABLE	0x00000100L
#define w32_MCI_OPEN_ELEMENT	0x00000200L
#define w32_MCI_OPEN_ALIAS		0x00000400L
#define w32_MCI_OPEN_ELEMENT_ID	0x00000800L
#define w32_MCI_OPEN_TYPE_ID	0x00001000L
#define w32_MCI_OPEN_TYPE		0x00002000L

#define w32_MCI_SEEK_TO_START	0x00000100L
#define w32_MCI_SEEK_TO_END		0x00000200L

#define w32_MCI_STATUS_ITEM		0x00000100L
#define w32_MCI_STATUS_START	0x00000200L

#define w32_MCI_STATUS_LENGTH	0x00000001L
#define w32_MCI_STATUS_POSITION	0x00000002L
#define w32_MCI_STATUS_NUMBER_OF_TRACKS	0x00000003L
#define w32_MCI_STATUS_MODE	0x00000004L
#define w32_MCI_STATUS_MEDIA_PRESENT	0x00000005L
#define w32_MCI_STATUS_TIME_FORMAT	0x00000006L
#define w32_MCI_STATUS_READY	0x00000007L
#define w32_MCI_STATUS_CURRENT_TRACK	0x00000008L

#define w32_MCI_CDA_STATUS_TYPE_TRACK	0x00004001L
#define w32_MCI_CDA_TRACK_AUDIO		(w32_MCI_CD_OFFSET + 0)
#define w32_MCI_CDA_TRACK_OTHER		(w32_MCI_CD_OFFSET + 1)

#define w32_MCI_VD_SEEK_REVERSE		0x00010000L




#define w32_MCI_INFO_PRODUCT		0x00000100L
#define w32_MCI_INFO_FILE			0x00000200L
#define w32_MCI_INFO_MEDIA_UPC		0x00000400L
#define w32_MCI_INFO_MEDIA_IDENTITY	0x00000800L
#define w32_MCI_INFO_NAME			0x00001000L
#define w32_MCI_INFO_COPYRIGHT		0x00002000L

#define w32_MCI_GETDEVCAPS_ITEM		0x00000100L

#define w32_MCI_GETDEVCAPS_CAN_RECORD	0x00000001L
#define w32_MCI_GETDEVCAPS_HAS_AUDIO	0x00000002L
#define w32_MCI_GETDEVCAPS_HAS_VIDEO	0x00000003L
#define w32_MCI_GETDEVCAPS_DEVICE_TYPE	0x00000004L
#define w32_MCI_GETDEVCAPS_USES_FILES	0x00000005L
#define w32_MCI_GETDEVCAPS_COMPOUND_DEVICE	0x00000006L
#define w32_MCI_GETDEVCAPS_CAN_EJECT	0x00000007L
#define w32_MCI_GETDEVCAPS_CAN_PLAY		0x00000008L
#define w32_MCI_GETDEVCAPS_CAN_SAVE		0x00000009L

#define w32_MCI_SYSINFO_QUANTITY	0x00000100L
#define w32_MCI_SYSINFO_OPEN		0x00000200L
#define w32_MCI_SYSINFO_NAME		0x00000400L
#define w32_MCI_SYSINFO_INSTALLNAME	0x00000800L

#define w32_MCI_SET_DOOR_OPEN	0x00000100L
#define w32_MCI_SET_DOOR_CLOSED	0x00000200L
#define w32_MCI_SET_TIME_FORMAT	0x00000400L
#define w32_MCI_SET_AUDIO		0x00000800L
#define w32_MCI_SET_VIDEO		0x00001000L
#define w32_MCI_SET_ON			0x00002000L
#define w32_MCI_SET_OFF			0x00004000L

#define w32_MCI_SET_AUDIO_ALL	0x00000000L
#define w32_MCI_SET_AUDIO_LEFT	0x00000001L
#define w32_MCI_SET_AUDIO_RIGHT	0x00000002L

#define w32_MCI_BREAK_KEY	0x00000100L
#define w32_MCI_BREAK_HWND	0x00000200L
#define w32_MCI_BREAK_OFF	0x00000400L

#define w32_MCI_RECORD_INSERT		0x00000100L
#define w32_MCI_RECORD_OVERWRITE	0x00000200L

#define w32_MCI_SAVE_FILE	0x00000100L
#define w32_MCI_LOAD_FILE	0x00000100L



#pragma pack(1)


struct _w32_mmtime_ {
	w32_UINT	wType;
	union {
		w32_DWORD	ms;
		w32_DWORD	samples;
		w32_DWORD	cb;
		w32_DWORD	ticks;
		struct {
			w32_BYTE	hour;
			w32_BYTE	min;
			w32_BYTE	sec;
			w32_BYTE	frame;
			w32_BYTE	fps;
			w32_BYTE	dummy;
			w32_BYTE	pad[2];
		} smpte;
		struct {
			w32_DWORD	songptrpos;
		} midi;
	} u;
};

struct _w32_auxcapsa_ {
	w32_DWORD		dwCallback;
	w32_MCIDEVICEID	wDeviceID;
	w32_LPSTR		lpstrDeviceType;
	w32_LPSTR		lpstrElementName;
	w32_LPSTR		lpstrAlias;
};

struct _w32_mci_open_parmsa_ {
	w32_DWORD		dwCallback;
	w32_MCIDEVICEID	wDeviceID;
	w32_LPSTR		lpstrDeviceType;
	w32_LPSTR		lpstrElementName;
	w32_LPSTR		lpstrAlias;
};

struct _w32_mci_generic_parms_ {
	w32_DWORD		dwCallback;
};

struct _w32_mci_getdevcaps_parms_ {
	w32_DWORD		dwCallback;
	w32_DWORD		dwReturn;
	w32_DWORD		dwItem;
};

struct _w32_mci_play_parms_ {
	w32_DWORD		dwCallback;
	w32_DWORD		dwFrom;
	w32_DWORD		dwTo;
};

struct _w32_mci_seek_parms_ {
	w32_DWORD	dwCallback;
	w32_DWORD	dwTo;
};

struct _w32_mci_status_parms_ {
	w32_DWORD	dwCallback;
	w32_DWORD	dwReturn;
	w32_DWORD	dwItem;
	w32_DWORD	dwTrack;
};

struct _w32_mci_info_parmsa_ {
	w32_DWORD	dwCallback;
	w32_LPSTR	lpstrReturn;
	w32_DWORD	dwRetSize;
};

struct _w32_mci_set_parms_ {
	w32_DWORD	dwCallback;
	w32_DWORD	dwTimeFormat;
	w32_DWORD	dwAudio;
};

struct _w32_wavehdr_ {
	w32_LPBYTE				lpData;
	DWORD					dwBufferLength;
	DWORD					dwBytesRecorded;
	DWORD					dwUser;
	DWORD					dwFlags;
	DWORD					dwLoops;
	struct _w32_wavehdr_	*lpNext;
	DWORD					reserved;
};

struct _w32_waveformat_ {
	WORD	wFormatTag;
	WORD	nChannels;
	DWORD	nSamplesPerSec;
	DWORD	nAvgBytesPerSec;
	WORD	nBlockAlign;
};

struct _w32_waveformatex_ {
	WORD	wFormatTag;
	WORD	nChannels;
	DWORD	nSamplesPerSec;
	DWORD	nAvgBytesPerSec;
	WORD	nBlockAlign;
	WORD	cbSize;
};

struct _w32_pcmwaveformat_ {
	struct _w32_waveformat_	wf;
	w32_WORD				wBitsPerSample;
};


struct _w32_waveoutcapsa_ {
	WORD			wMid;
	WORD			wPid;
	w32_MMVERSION	vDriverVersion;
	char			szPname[w32_MAXPNAMELEN];
	DWORD			dwFormats;
	WORD			wChannels;
	WORD			wReserved1;
	DWORD			dwSupport;
};


DECL_W32TYPE(struct _w32_mmtime_, MMTIME)
DECL_W32TYPE(struct _w32_auxcapsa_, AUXCAPSA)
DECL_W32TYPE(struct _w32_mci_open_parmsa_, MCI_OPEN_PARMSA)
DECL_W32TYPE(struct _w32_mci_generic_parms_, MCI_GENERIC_PARMS)
DECL_W32TYPE(struct _w32_mci_getdevcaps_parms_, MCI_GETDEVCAPS_PARMS)
DECL_W32TYPE(struct _w32_mci_play_parms_, MCI_PLAY_PARMS)
DECL_W32TYPE(struct _w32_mci_seek_parms_, MCI_SEEK_PARMS)
DECL_W32TYPE(struct _w32_mci_status_parms_, MCI_STATUS_PARMS)
DECL_W32TYPE(struct _w32_mci_info_parmsa_, MCI_INFO_PARMSA)
DECL_W32TYPE(struct _w32_mci_set_parms_, MCI_SET_PARMS)

DECL_W32TYPE(struct _w32_wavehdr_, WAVEHDR)
DECL_W32TYPE(struct _w32_waveformat_, WAVEFORMAT)
DECL_W32TYPE(struct _w32_waveformatex_, WAVEFORMATEX)
DECL_W32TYPE(struct _w32_waveoutcapsa_, WAVEOUTCAPSA)

DECL_W32TYPE(struct _w32_pcmwaveformat_, PCMWAVEFORMAT)



/*

*/

w32_MMRESULT w32_API  wrap_timeGetSystemTime(w32_LPMMTIME, UINT);
w32_MMRESULT w32_API  w32_timeGetSystemTime(w32_LPMMTIME, UINT);

DWORD w32_API  wrap_timeGetTime(void);
DWORD w32_API  w32_timeGetTime(void);

UINT w32_API  wrap_auxGetNumDevs(void);
UINT w32_API  w32_auxGetNumDevs(void);

w32_MMRESULT w32_API  wrap_auxGetDevCapsA(UINT, w32_LPAUXCAPSA, UINT);
w32_MMRESULT w32_API  w32_auxGetDevCapsA(UINT, w32_LPAUXCAPSA, UINT);

w32_MMRESULT w32_API  wrap_auxSetVolume(UINT, w32_DWORD);
w32_MMRESULT w32_API  w32_auxSetVolume(UINT, w32_DWORD);

w32_MMRESULT w32_API  wrap_auxGetVolume(UINT, w32_LPDWORD);
w32_MMRESULT w32_API  w32_auxGetVolume(UINT, w32_LPDWORD);

w32_MCIERROR w32_API  wrap_mciSendCommandA(w32_MCIDEVICEID, UINT, DWORD, DWORD);
w32_MCIERROR w32_API  w32_mciSendCommandA(w32_MCIDEVICEID, UINT, DWORD, DWORD);
w32_MCIERROR w32_API  w32_mciSendStringA(w32_LPSTR, w32_LPSTR, UINT, DWORD);

BOOL w32_API  wrap_mciGetErrorStringA(w32_MCIERROR, w32_LPSTR, UINT);
BOOL w32_API  w32_mciGetErrorStringA(w32_MCIERROR, w32_LPSTR, UINT);


w32_MMRESULT w32_API  w32_waveOutPrepareHeader(w32_HWAVEOUT, w32_LPWAVEHDR, UINT);
w32_MMRESULT w32_API  wrap_waveOutPrepareHeader(w32_HWAVEOUT, w32_LPWAVEHDR, UINT);
w32_MMRESULT w32_API  w32_waveOutUnprepareHeader(w32_HWAVEOUT, w32_LPWAVEHDR, UINT);
w32_MMRESULT w32_API  wrap_waveOutUnprepareHeader(w32_HWAVEOUT, w32_LPWAVEHDR, UINT);

w32_MMRESULT w32_API  w32_waveOutGetVolume(UINT, w32_LPDWORD);
w32_MMRESULT w32_API  wrap_waveOutGetVolume(UINT, w32_LPDWORD);
w32_MMRESULT w32_API  w32_waveOutSetVolume(UINT, DWORD);
w32_MMRESULT w32_API  wrap_waveOutSetVolume(UINT, DWORD);

w32_MMRESULT w32_API  w32_waveOutOpen(w32_LPHWAVEOUT, UINT, w32_LPWAVEFORMAT, DWORD , DWORD, DWORD);
w32_MMRESULT w32_API  wrap_waveOutOpen(w32_LPHWAVEOUT, UINT, w32_LPWAVEFORMAT, DWORD , DWORD, DWORD);

w32_MMRESULT w32_API  w32_waveOutClose(w32_HWAVEOUT);
w32_MMRESULT w32_API  wrap_waveOutClose(w32_HWAVEOUT);

w32_MMRESULT w32_API  w32_waveOutWrite(w32_HWAVEOUT, w32_LPWAVEHDR, UINT);
w32_MMRESULT w32_API  wrap_waveOutWrite(w32_HWAVEOUT, w32_LPWAVEHDR, UINT);
w32_MMRESULT w32_API  w32_waveOutReset(w32_HWAVEOUT);
w32_MMRESULT w32_API  wrap_waveOutReset(w32_HWAVEOUT);

w32_MMRESULT w32_API  w32_waveOutGetDevCapsA(UINT, w32_LPWAVEOUTCAPSA, UINT);
w32_MMRESULT w32_API  wrap_waveOutGetDevCapsA(UINT, w32_LPWAVEOUTCAPSA, UINT);



/*

*/

#define w32_MIXER_SHORT_NAME_CHARS		16
#define w32_MIXER_LONG_NAME_CHARS		64

struct _w32_mixercapsa_ {
	WORD			wMid;
	WORD			wPid;
	w32_MMVERSION	vDriverVersion;
	char			szPname[w32_MAXPNAMELEN];
	DWORD			fdwSupport;
	DWORD			cDestinations;
};

struct _w32_mixerlinea_ {
	DWORD		cbStruct;
	DWORD		dwDestination;
	DWORD		dwSource;
	DWORD		dwLineID;
	DWORD		fdwLine;
	DWORD		dwUser;
	DWORD		dwComponentType;
	DWORD		cChannels;
	DWORD		cConnections;
	DWORD		cControls;
	char		szShortName[w32_MIXER_SHORT_NAME_CHARS];
	char		szName[w32_MIXER_LONG_NAME_CHARS];
	struct {
	DWORD			dwType;
	DWORD			dwDeviceID;
	WORD			wMid;
	WORD			wPid;
	w32_MMVERSION	vDriverVersion;
	char			szPname[w32_MAXPNAMELEN];
	} Target;
};


struct _w32_mixercontrola_ {
	DWORD		cbStruct;
	DWORD		dwControlID;
	DWORD		dwControlType;
	DWORD		fdwControl;
	DWORD		cMultipleItems;
	char		szShortName[w32_MIXER_SHORT_NAME_CHARS];
	char		szName[w32_MIXER_LONG_NAME_CHARS];
	union {
		struct {
			LONG	lMinimum;
			LONG	lMaximum;
		}
#ifdef __EMX__
		mixfield_signed
#endif
		;
		struct {
			DWORD	dwMinimum;
			DWORD	dwMaximum;
		}
#ifdef __EMX__
		mixfield_unsigned
#endif
		;
		DWORD	dwReserved[6];
	} Bounds;
	union {
		DWORD	cSteps;
		DWORD	cbCustomData;
		DWORD	dwReserved[6];
	} Metrics;
};

struct _w32_mixerlinecontrola_ {
	DWORD		cbStruct;
	DWORD		dwLineID;
	union {
		DWORD	dwControlID;
		DWORD	dwControlType;
	}
#ifdef __EMX__
	id_or_type
#endif
	;
	DWORD		cControls;
	DWORD		cbmxctrl;
	struct _w32_mixercontrola_  *pamxctrl;
};

struct _w32_mixercontroldetails_ {
	DWORD		cbStruct;
	DWORD		dwControlID;
	DWORD		cChannels;
	union {
		HWND	hwndOwner;
		DWORD	cMultipleItems;
	}
#ifdef __EMX__
	hwnd_or_citems
#endif
	;
	DWORD		cbDetails;
	w32_LPVOID		paDetails;
};

DECL_W32TYPE(struct _w32_mixercapsa_, MIXERCAPSA)
DECL_W32TYPE(struct _w32_mixerlinea_, MIXERLINEA)
DECL_W32TYPE(struct _w32_mixercontrola_, MIXERCONTROLA)
DECL_W32TYPE(struct _w32_mixerlinecontrola_, MIXERLINECONTROLSA)
DECL_W32TYPE(struct _w32_mixercontroldetails_, MIXERCONTROLDETAILS)


UINT w32_API  w32_mixerGetNumDevs(void);
UINT w32_API  wrap_mixerGetNumDevs(void);

w32_MMRESULT w32_API  w32_mixerGetDevCapsA(UINT, w32_LPMIXERCAPSA, UINT);
w32_MMRESULT w32_API  wrap_mixerGetDevCapsA(UINT, w32_LPMIXERCAPSA, UINT);

w32_MMRESULT w32_API  w32_mixerOpen(w32_LPHMIXER, UINT, DWORD, DWORD, DWORD);
w32_MMRESULT w32_API  wrap_mixerOpen(w32_LPHMIXER, UINT, DWORD, DWORD, DWORD);

w32_MMRESULT w32_API  w32_mixerClose(w32_HMIXER);
w32_MMRESULT w32_API  wrap_mixerClose(w32_HMIXER);

DWORD w32_API  w32_mixerMessage(w32_HMIXER, UINT, DWORD, DWORD);
DWORD w32_API  wrap_mixerMessage(w32_HMIXER, UINT, DWORD, DWORD);

w32_MMRESULT w32_API  w32_mixerGetLineInfoA(w32_HMIXEROBJ, w32_LPMIXERLINEA, DWORD);
w32_MMRESULT w32_API  wrap_mixerGetLineInfoA(w32_HMIXEROBJ, w32_LPMIXERLINEA, DWORD);
w32_MMRESULT w32_API  w32_mixerGetID(w32_HMIXEROBJ, UINT *, DWORD);
w32_MMRESULT w32_API  wrap_mixerGetID(w32_HMIXEROBJ, UINT *, DWORD);

w32_MMRESULT w32_API  w32_mixerGetLineControlsA(w32_HMIXEROBJ, w32_LPMIXERLINECONTROLSA, DWORD);
w32_MMRESULT w32_API  wrap_mixerGetLineControlsA(w32_HMIXEROBJ, w32_LPMIXERLINECONTROLSA, DWORD);

w32_MMRESULT w32_API  w32_mixerGetControlDetailsA(w32_HMIXEROBJ, w32_LPMIXERCONTROLDETAILS, DWORD);
w32_MMRESULT w32_API  wrap_mixerGetControlDetailsA(w32_HMIXEROBJ, w32_LPMIXERCONTROLDETAILS, DWORD);

w32_MMRESULT w32_API  w32_mixerSetControlDetails(w32_HMIXEROBJ, w32_LPMIXERCONTROLDETAILS, DWORD);
w32_MMRESULT w32_API  wrap_mixerSetControlDetails(w32_HMIXEROBJ, w32_LPMIXERCONTROLDETAILS, DWORD);


#if defined(__WATCOMC__)
#pragma aux (_stdcall_wc) wrap_timeGetSystemTime;
#pragma aux (_stdcall_wc) w32_timeGetSystemTime;
#pragma aux (_stdcall_wc) wrap_auxGetNumDevs;
#pragma aux (_stdcall_wc) w32_auxGetNumDevs;
#pragma aux (_stdcall_wc) wrap_auxGetDevCapsA;
#pragma aux (_stdcall_wc) w32_auxGetDevCapsA;
#pragma aux (_stdcall_wc) wrap_auxSetVolume;
#pragma aux (_stdcall_wc) w32_auxSetVolume;
#pragma aux (_stdcall_wc) wrap_auxGetVolume;
#pragma aux (_stdcall_wc) w32_auxGetVolume;
#pragma aux (_stdcall_wc) wrap_mciSendCommandA;
#pragma aux (_stdcall_wc) w32_mciSendCommandA;
#pragma aux (_stdcall_wc) wrap_mciGetErrorStringA;
#pragma aux (_stdcall_wc) w32_mciGetErrorStringA;
#pragma aux (_stdcall_wc) wrap_timeGetTime;
#pragma aux (_stdcall_wc) w32_timeGetTime;

#pragma aux (_stdcall_wc) wrap_waveOutPrepareHeader;
#pragma aux (_stdcall_wc) w32_waveOutPrepareHeader;
#pragma aux (_stdcall_wc) wrap_waveOutUnprepareHeader;
#pragma aux (_stdcall_wc) w32_waveOutUnprepareHeader;
#pragma aux (_stdcall_wc) wrap_waveOutGetVolume;
#pragma aux (_stdcall_wc) w32_waveOutGetVolume;
#pragma aux (_stdcall_wc) wrap_waveOutSetVolume;
#pragma aux (_stdcall_wc) w32_waveOutSetVolume;
#pragma aux (_stdcall_wc) wrap_waveOutOpen;
#pragma aux (_stdcall_wc) w32_waveOutOpen;
#pragma aux (_stdcall_wc) wrap_waveOutClose;
#pragma aux (_stdcall_wc) w32_waveOutClose;
#pragma aux (_stdcall_wc) wrap_waveOutWrite;
#pragma aux (_stdcall_wc) w32_waveOutWrite;
#pragma aux (_stdcall_wc) wrap_waveOutReset;
#pragma aux (_stdcall_wc) w32_waveOutReset;
#pragma aux (_stdcall_wc) wrap_waveOutGetDevCapsA;
#pragma aux (_stdcall_wc) w32_waveOutGetDevCapsA;

#pragma aux (_stdcall_wc) w32_mixerGetNumDevs;
#pragma aux (_stdcall_wc) wrap_mixerGetNumDevs;
#pragma aux (_stdcall_wc) w32_mixerGetDevCapsA;
#pragma aux (_stdcall_wc) wrap_mixerGetDevCapsA;
#pragma aux (_stdcall_wc) w32_mixerOpen;
#pragma aux (_stdcall_wc) wrap_mixerOpen;
#pragma aux (_stdcall_wc) w32_mixerClose;
#pragma aux (_stdcall_wc) wrap_mixerClose;
#pragma aux (_stdcall_wc) w32_mixerMessage;
#pragma aux (_stdcall_wc) wrap_mixerMessage;
#pragma aux (_stdcall_wc) w32_mixerGetLineInfoA;
#pragma aux (_stdcall_wc) wrap_mixerGetLineInfoA;
#pragma aux (_stdcall_wc) w32_mixerGetID;
#pragma aux (_stdcall_wc) wrap_mixerGetID;
#pragma aux (_stdcall_wc) w32_mixerGetLineControlsA;
#pragma aux (_stdcall_wc) wrap_mixerGetLineControlsA;
#pragma aux (_stdcall_wc) w32_mixerGetControlDetailsA;
#pragma aux (_stdcall_wc) wrap_mixerGetControlDetailsA;
#pragma aux (_stdcall_wc) w32_mixerSetControlDetails;
#pragma aux (_stdcall_wc) wrap_mixerSetControlDetails;

#endif




#pragma pack()

#ifdef __cplusplus
}
#endif

#endif /* svwrap_w32mm_h__ */
